#ifndef _NET_PROTO_H_
#define _NET_PROTO_H_

/* This file is automatically generated with "make proto". DO NOT EDIT */


/* The following definitions come from utils/net.c  */

uint32 get_sec_channel_type(const char *param) ;
int net_run_function(int argc, const char **argv, struct functable *table, 
		     int (*usage_fn)(int argc, const char **argv));
NTSTATUS connect_to_ipc(struct cli_state **c, struct in_addr *server_ip,
					const char *server_name);
NTSTATUS connect_to_ipc_anonymous(struct cli_state **c,
			struct in_addr *server_ip, const char *server_name);
int net_use_machine_password(void) ;
BOOL net_find_server(unsigned flags, struct in_addr *server_ip, char **server_name);
BOOL net_find_pdc(struct in_addr *server_ip, fstring server_name, const char *domain_name);
struct cli_state *net_make_ipc_connection(unsigned flags);
int net_afskey_usage(int argc, const char **argv);

/* The following definitions come from utils/net_ads.c  */

int net_ads_usage(int argc, const char **argv);
int net_ads_check(void);
int net_ads_user(int argc, const char **argv);
int net_ads_group(int argc, const char **argv);
int net_ads_testjoin(int argc, const char **argv);
int net_ads_join(int argc, const char **argv);
int net_ads_printer_usage(int argc, const char **argv);
void do_drv_upgrade_printer(int msg_type, pid_t src, void *buf, size_t len);
int net_ads_changetrustpw(int argc, const char **argv);
int net_ads_help(int argc, const char **argv);
int net_ads(int argc, const char **argv);
int net_ads_usage(int argc, const char **argv);
int net_ads_help(int argc, const char **argv);
int net_ads_changetrustpw(int argc, const char **argv);
int net_ads_join(int argc, const char **argv);
int net_ads_user(int argc, const char **argv);
int net_ads_group(int argc, const char **argv);
int net_ads_check(void);
int net_ads(int argc, const char **argv);

/* The following definitions come from utils/net_ads_cldap.c  */

int ads_cldap_netlogon(ADS_STRUCT *ads);

/* The following definitions come from utils/net_cache.c  */

int net_cache(int argc, const char **argv);

/* The following definitions come from utils/net_groupmap.c  */

int net_help_groupmap(int argc, const char **argv);
int net_groupmap(int argc, const char **argv);

/* The following definitions come from utils/net_help.c  */

int net_common_methods_usage(int argc, const char**argv);
int net_common_flags_usage(int argc, const char **argv);
int net_help_user(int argc, const char **argv);
int net_help_group(int argc, const char **argv);
int net_help_join(int argc, const char **argv);
int net_help_share(int argc, const char **argv);
int net_help_file(int argc, const char **argv);
int net_help_status(int argc, const char **argv);
int net_help(int argc, const char **argv);

/* The following definitions come from utils/net_idmap.c  */

int net_help_idmap(int argc, const char **argv);
int net_idmap(int argc, const char **argv);

/* The following definitions come from utils/net_lookup.c  */

int net_lookup_usage(int argc, const char **argv);
int net_lookup(int argc, const char **argv);

/* The following definitions come from utils/net_rap.c  */

int net_rap_file_usage(int argc, const char **argv);
int net_rap_file(int argc, const char **argv);
int net_rap_share_usage(int argc, const char **argv);
int net_rap_share(int argc, const char **argv);
int net_rap_session_usage(int argc, const char **argv);
int net_rap_session(int argc, const char **argv);
int net_rap_server_usage(int argc, const char **argv);
int net_rap_server(int argc, const char **argv);
int net_rap_domain_usage(int argc, const char **argv);
int net_rap_domain(int argc, const char **argv);
int net_rap_printq_usage(int argc, const char **argv);
int net_rap_printq(int argc, const char **argv);
int net_rap_user(int argc, const char **argv);
int net_rap_group_usage(int argc, const char **argv);
int net_rap_group(int argc, const char **argv);
int net_rap_groupmember_usage(int argc, const char **argv);
int net_rap_groupmember(int argc, const char **argv);
int net_rap_validate_usage(int argc, const char **argv);
int net_rap_validate(int argc, const char **argv);
int net_rap_service_usage(int argc, const char **argv);
int net_rap_service(int argc, const char **argv);
int net_rap_password_usage(int argc, const char **argv);
int net_rap_password(int argc, const char **argv);
int net_rap_admin_usage(int argc, const char **argv);
int net_rap_admin(int argc, const char **argv);
int net_rap_usage(int argc, const char **argv);
int net_rap_help(int argc, const char **argv);
int net_rap(int argc, const char **argv);

/* The following definitions come from utils/net_rpc.c  */

int net_rpc_changetrustpw(int argc, const char **argv) ;
int net_rpc_join(int argc, const char **argv) ;
int net_rpc_info(int argc, const char **argv) ;
int net_rpc_getsid(int argc, const char **argv) ;
int net_rpc_user(int argc, const char **argv) ;
int net_rpc_group(int argc, const char **argv) ;
int net_rpc_share(int argc, const char **argv) ;
int net_rpc_file(int argc, const char **argv) ;
BOOL net_rpc_check(unsigned flags);
int net_rpc_usage(int argc, const char **argv) ;
int net_rpc_help(int argc, const char **argv);
int net_rpc(int argc, const char **argv);

/* The following definitions come from utils/net_rpc_join.c  */

int net_rpc_join_newstyle(int argc, const char **argv) ;
int net_rpc_testjoin(int argc, const char **argv) ;

/* The following definitions come from utils/net_rpc_samsync.c  */

NTSTATUS rpc_samdump_internals(const DOM_SID *domain_sid, 
			       const char *domain_name, 
			       struct cli_state *cli, TALLOC_CTX *mem_ctx, 
			       int argc, const char **argv) ;
NTSTATUS rpc_vampire_internals(const DOM_SID *domain_sid, 
			       const char *domain_name, 
			       struct cli_state *cli, TALLOC_CTX *mem_ctx, 
			       int argc, const char **argv) ;

/* The following definitions come from utils/net_status.c  */

int net_status(int argc, const char **argv);

/* The following definitions come from utils/net_time.c  */

int net_time_usage(int argc, const char **argv);
int net_time(int argc, const char **argv);

#endif /*  _NET_PROTO_H_  */
